# Grichelde - Text replacer

Grichelde is a WoW Classic Addon that replaces any characters or words you typed in a chatbox with any replacement text or word you specified.
You can define any search and replace text arbitrarily. The replacement is done **before** the text is send to others/in the target channel. 
It does **not** change txt others have written in the chat/channel.

Its purpose it to simulate a speaking disability of your toon and hereby strengthen immersion in roleplay. 
Initially started as a helper addon for a roleplaying friend, Grichelde can be used for much more, like 

* fixing your common spelling errors :)
* replacing toon names with their nick names
* write out abbreviations for you
* create hilarious moments during roleplay

## Disclaimer
#### No Warranty
The addon is provided "AS IS" and comes without warranty of any kind of function or correctness (for more details, consult the GPL 3 license).
Also the author is not held responsible for any risk or damage the addon or its use might cause, especially lost of progress or data due to crashes of the WoW client.

#### Respect others
This addon does not encourange or intend to hurt or to tease people with speaking disabilities or language disorders. 
The responsibility rest on the user completely. Please use the features with care and respect to other players.
                                 
## FAQ

#### Where do I start?

Grichelde is active right from the start with default mappings. To open the options UI, either left-click on
the new minimap icon, or type `/gri` or `/grichelde` in the chatbox. All mappings and channels can be configured there.

#### Does it replace only letters but also whole words?

Grichelde is capable of handling both, even whole sentences can be replaced. 
Only slash commands, item links, textures, placeholders and ooc-markers are excluded from replacement.

#### My replacement is not taken.

After entering a search or replacement text, you see a button "Okay" next to yout input. This is **not** a validation message, 
but the save button for text. This is a restriction from the UI library and can be seen in other addons as well. 
Please click on "Okay" button to save the input permanently.

If it still does not work or gives you errors, please read the next question. 

#### I have to disable the Addon frequently. Is there a more elegant solution

Actually there are two solutions:
1. A right-click on the minimap button will disable Grichelde instantly. Right-click a second time will activate it again. Easy, isn't it?
2. You can disable Grichelde permanently and forcefully replace the sentence in the chatbox. I call it "Grichelde-On-Demand" :) 
   In the chatbox put `/gri` or `/grichelde` in front of your typed text, you can also include the target channel, 
   i.e. `/gri /guild hello there` and Grichelde will apply the active replacements even if guild channel or Grichelde was disabled.

#### I get errors, what should I do?

Please report your errors on [project website](https://www.curseforge.com/wow/addons/grichelde) at curse forge. Make a screenshot or copy both the error message as well as your recent mappings.
You can bring up a small windows with your mapping by entering the `/gri mappings` command on copy them.

#### Why that strange name?

Grichelde is the name of an Undead rogue without a jaw, who was played in RP sessions with a guild member.
She started replacing "s" and "t" letters manually for each line in the chat, which became cumbersome over time.
(If you ever wondered how an Undead without a jaw sounds like, its really hilarious, you should try it.) 
Without spelling errors, "Griselde" in German is an old-fashioned female first name.

#### I'm a Pro. Does it support regular expressions?

This is actually an unofficial feature. In general the searchText is passed in as Lua, so yes regex can be used in lookups.
There are two caveats: first, Lua does not support PCRE syntax, as it would bloat Lua's simplicity and performance (read [here](http://www.lua.org/pil/20.1.html) why).
Secondly, Grichelde does not support capture groups in the replacement text, so matches get lost. 