-- read namespace from global env
local AddonName, _ = ...
local _G = _G
local Grichelde = _G.Grichelde

local L = LibStub('AceLocale-3.0'):NewLocale(AddonName, 'enUS', true)
if not L then return end

local cYellow = Grichelde.functions.cYellow
local cGray = Grichelde.functions.cGray
local cPrefix = Grichelde.functions.cPrefix

-- system messages
L.AddonName = "Grichelde"
L.AddonNamePlusVersion = "%s v%s"
L.AddonLoaded = "%s happily assists you with your spelling disabilities now."
L.AddonUnloaded = "%s patiently waits to support you again when needed."
L.Upgrade_ToVersion = "Upgrade database to version %s."
L.Upgrade_Successful = "Upgrade successful."

-- debug
L.Debug_Options = "Options"
L.Debug_Mappings = "Mappings"
L.Debug_Mappings_Hint = "The content of this input box is used for debugging purposes only and can be copied. No input from this box will be read or processed."
L.Debug_Mappings_Found = "%d mappings found"
L.Debug_Profile = "Profile"

-- errors
L.Error_InvalidCommand = "Invalid command"
L.Error_InvalidChannel = "Invalid channel"
L.Error_InvalidWhisperTarget = "Invalid whisper target"
L.Error_UnsupportedChannel = "Unsupported channel"

-- profiles
L.Profiles_Available = "Available profiles:"
L.Profiles_Created = "New profile %s created."
L.Profiles_Loaded = "Profile %s is loaded."
L.Profiles_Refreshed = "Profil %s refreshed."
L.Profiles_Deleted = "Profile %s deleted."
L.Profiles_Copied = "Settings applied from profile %s."
L.Profiles_Reset = "Profil %s reset."
L.Profiles_Invalid = "Invalid profile %s!"
L.Profiles_DeleteError = "The active profile cannot be deleted!"

-- minimap
L.Minimap_Tooltip_Enabled = "%s"
L.Minimap_Tooltip_Disabled = "%s " .. cGray("(inactive)")
L.Minimap_Tooltip_Options_Left = "Left-Click"
L.Minimap_Tooltip_Options_Right = "Opens or closes the options UI."
L.Minimap_Tooltip_Mappings_Left = "Right-Click"
L.Minimap_Tooltip_Mappings_Right = "Enables or disables any replacements."

-- options
L.Options_Title = "%s Options"
L.Options_Enabled_Name = "Enabled"
L.Options_Enabled_Desc = "Enables %s"
L.Options_Minimap_Button_Name = "Show minimap button"
L.Options_Minimap_Button_Desc = "Shows or hides the button on the minimap."

L.Options_Channels_Group_Name = "Channels"
L.Options_Channels_Group_Desc = "%s is active in the following channels."
L.Options_Channels_Header = "Text replacement will only be done for marked channels below:"

L.Options_Channel_Say_Name = "Say"
L.Options_Channel_Say_Desc = "Activates %s in channel \"Say\"."
L.Options_Channel_Emote_Name = "Emote"
L.Options_Channel_Emote_Desc = "Activates %s in channel \"Emote\"."
L.Options_Channel_Yell_Name = "Yell"
L.Options_Channel_Yell_Desc = "Activates %s in channel \"Yell\"."
L.Options_Channel_Party_Name = "Party"
L.Options_Channel_Party_Desc = "Activates %s in channel \"Party\"."
L.Options_Channel_PartyLeader_Name = "Party Leader"
L.Options_Channel_PartyLeader_Desc = "Activates %s in channel \"Party Leader\"."
L.Options_Channel_Guild_Name = "Guild"
L.Options_Channel_Guild_Desc = "Activates %s in channel \"Guild\"."
L.Options_Channel_Officer_Name = "Officers"
L.Options_Channel_Officer_Desc = "Activates %s in channel \"Officers\"."
L.Options_Channel_Raid_Name = "Raid"
L.Options_Channel_Raid_Desc = "Activates %s in channel \"Raid\"."
L.Options_Channel_RaidLeader_Name = "Raid Leader"
L.Options_Channel_RaidLeader_Desc = "Activates %s in channel \"Raid Leader\"."
L.Options_Channel_RaidWarning_Name = "Raid Warning"
L.Options_Channel_RaidWarning_Desc = "Activates %s in channel \"Raid Warning\"."
L.Options_Channel_Instance_Name = "Instance"
L.Options_Channel_Instance_Desc = "Activates %s in channel \"Instance\"."
L.Options_Channel_Battleground_Name = "Battleground"
L.Options_Channel_Battleground_Desc = "Activates %s in channel \"Battleground\"."
L.Options_Channel_Whisper_Name = "Whisper"
L.Options_Channel_Whisper_Desc = "Activates %s in channel \"Whisper\"."

L.Options_Replacements_Group_Name = "Replacements"
L.Options_Replacements_Group_Desc = "These lookups will be replaced in activated channels."
L.Options_Replacements_Add_Name = "Add"
L.Options_Replacements_Add_Desc = "Adds a new replacement mapping."
L.Options_Replacements_DeleteAll_Name = "Delete All"
L.Options_Replacements_DeleteAll_Desc = "Deletes all replacement mappings."
L.Options_Replacements_DeleteAll_ConfirmText = "Do you really want to delete ALL replacement mappings?"
L.Options_Replacements_Header = "All matches on the lefthand side of the arrow \"=>\" will be replaced in activated channels by the text on the righthand side. "

L.Options_Mapping_Group_Name = "%s => %s"
L.Options_Mapping_Group_Desc = "This lookup will be replaced in activated channels."
L.Options_Mapping_EmptyMapping = "(none)"
L.Options_Mapping_Enabled_Name = "active"
L.Options_Mapping_Enabled_Desc = "This replacement will be processed."
L.Options_Mapping_SearchText_Name = "Search for:"
L.Options_Mapping_SearchText_Desc = "This text is looked up in your chat input box."
L.Options_Mapping_ReplaceText_Name = "Replacement:"
L.Options_Mapping_ReplaceText_Desc = "Any match will be replaced with this text."
L.Options_Mapping_ExactCase_Name = "exact case"
L.Options_Mapping_ExactCase_Desc = "When set, matches must be case-sensitive. Otherwise the case for each letter of the matching text is taken over when replaced."
L.Options_Mapping_Consolidate_Name = "consolidate consecutive matches"
L.Options_Mapping_Consolidate_Desc = "If after the replacement a text sequence is repeated|ndirectly after another, treat them as one occurrence."
L.Options_Mapping_StopOnMatch_Name = "stop on match"
L.Options_Mapping_StopOnMatch_Desc = "Stops looking for any following replacements, when this one matched."
L.Options_Mapping_MoveUp_Name = "^"
L.Options_Mapping_MoveUp_Desc = "move up"
L.Options_Mapping_MoveDown_Name = "v"
L.Options_Mapping_MoveDown_Desc = "move down"
L.Options_Mapping_Delete_Name = "Delete"
L.Options_Mapping_Delete_Desc = "Deletes this replacement mapping."
L.Options_Mapping_Delete_ConfirmText = "Delete this replacement mapping?"

L.Options_Help_Group_Name = "Help"
L.Options_Help_Group_Desc = "Guideance to search patterns and replacement logic."
L.Options_Help_Disclaimer = cYellow("Disclaimer of warranty:") .. " The addon is provided \"AS IS\" and comes without warranty of any kind of function or correctness (for more details, consult the GPL 3 license). "
                            .."Also the author is not held responsible for any risk or damage the addon or its use might cause, especially lost of progress or data due to crashes of the WoW client."

L.Options_Help_Tab_Basics_Name = "Basics"
L.Options_Help_Tab_Basics_Desc = "Some explanatory notes the the basic behaviour."
L.Options_Help_Tab_Expert_Name = "Expert"
L.Options_Help_Tab_Expert_Desc = "More details on special search options."
L.Options_Help_Tab_Examples_Name = "Examples"
L.Options_Help_Tab_Examples_Desc = "Templates for particular scenarios."

L.Options_Help_Basics = cYellow("Ordering")
                        .. "|nYou can have an unlimited number of replacements. All mappings will be processed in same order as defined, from top down. "
                        .. "Replacements are also transitive, so consecutive mappings do not work on the original input but the resulting text from the previous replacements. "
                        .. "|nBoth mappings " .. cPrefix("\"a\" => \"b\"") .. " and " .. cPrefix("\"b\" => \"c\"") .. " applied, result in the final text " .. cPrefix("\"a\" => \"c\"") .. "."
                        .. "|n|n" .. cYellow("exact case")
                        .. "|nIf \"exact case\" is checked, lower and upper case must match exactly to be replaced, otherwise the mapping is skipped. "
                        .. "If case sensivity is ignored, the case for each letter of the matching text is taken over when replaced. "
                        .. "|nWith mapping " .. cPrefix("\"aBcDeF\" => \"uvWXYz\"") .. " text results in " .. cPrefix("\"abcdef\" => \"uvwxyz\"") .. ", "
                        .. "also " .. cPrefix("\"ABCDEF\" => \"UVWXYZ\"") .. " and " .. cPrefix("\"AbCdEf\" => \"UvWxYz\"") .. "."
                        .. "|n|n" .. cYellow("consolidate consecutive matches")
                        .. "|nConsolidation of consecutive matches prevent unaesthetic repetitions of letters introduced during replacements. "
                        .. "Consolidation takes place after all replacements were done, meaning it's applied to the completely replaced text. "
                        .. "|nWith mapping " .. cPrefix("\"s\" => \"sh\"") .. " text becomes " .. cPrefix("\"tossing\" => \"toshing\"") .. " instead of " .. cPrefix("\"toshshing\"") .. ", yet still " .. cPrefix("\"paths\" => \"pathsh\"") .. ". "
                        .. "Such edge cases can usually be mitigated with an additional mapping at the end: " .. cPrefix("\"thsh\" => \"thz\"") .. "."
                        .. "|n|n" .. cYellow("stop on match")
                        .. "|nNo other replacements are done, when the current mapping matched. This will skip any other consecutive mappings when hit. When no match ocurred, the remaining mappings are processed as usual."
L.Options_Help_Expert = cYellow("shortening/lengthening replacements")
                        .. "|nIf the replacement is shorter than the actual match, all remaining characters will be skipped. If the replacement is longer, all remaining characters will be appended. "
                        .. "The case of the replaced character is considered as well as the case of the next character in the original text. That way capital case abbreviations and expressions will not be distorted. "
                        .. "|nWith mapping " .. cPrefix("\"Body\" => \"Corpse\"") .. " the input becomes " .. cPrefix("\"BODY\" => \"CORPSE\"") .. " instead of " .. cPrefix("\"CORPse\"") .. " "
                        .. "but still keeps intended exceptions like " .. cPrefix("\"BodYGuard\" => \"CorPSEGuard\"") .. " instead of " .. cPrefix("\"CorpseGuard\"") .. ". "
                        .. "|n|n" .. cYellow("On-Demand")
                        .. "|nFor convenience input text in a chatbox can be forcefully replaced, even if the addon or the channel was disabled. "
                        .. "In the chatbox put " .. cPrefix("/gri") .. " or " .. cPrefix("/grichelde") .. " in front of your typed text, you can also include the target channel, "
                        .. "i.e. " .. cPrefix("\"/gri /guild hello there\"") .. " and the active replacements are applied even if the guild channel or global switch was disabled."
                        .. "|n|n" .. cYellow("Regular Expressions")
                        .. "|nRegex are very powerful search and replacement patterns commonly used in programming. Technically all searches the addon performs on the input text are done with regular expression methods. "
                        .. "Entering regex as search text however is an unofficial feature and has two major caveats: "
                        .. "|n1. Unfornately Lua does not support full PCRE syntax and is very limited. Nethertheless some patterns can be used like start of line " .. cPrefix("\"^\"") .. " or end of line " .. cPrefix("\"$\"") .. ", "
                        .. "character classes like numbers " .. cPrefix("\"%d\"") .. " or (inversed) sets " .. cPrefix("\"[^%p]\"") .. ". "
                        .. "|n2. There is no support for capture groups in the replacement text, so matches get lost. Because of case sensivity and complexity there are no plans to support this."
                        .. "|nAnyway, there are some mappings using RegEx in the Example secion."


L.Options_Help_Examples_Note = cYellow("Note:") .. " This addon does not encourange or intend to hurt or to tease people with speaking disabilities or language disorders. The responsibility rest on the user completely. Please use the features with care and respect to other players."
L.Options_Help_Examples0_Header = cYellow("Example")
L.Options_Help_Examples0_Text = "Select an example from the dropdown above."
L.Options_Help_Examples1_Select = "absent jaw"
L.Options_Help_Examples1_Header = cYellow("S and P will be replaced by sibilant and clack sounds.")
L.Options_Help_Examples1_Text = cPrefix("s => ch") .. "|n|n" .. cPrefix("t => ck")
L.Options_Help_Examples2_Select = "trollifier"
L.Options_Help_Examples2_Header = cYellow("Almost sound like a real Troll.")
L.Options_Help_Examples2_Text = cPrefix("%.$ => , mon.") .. "|n|n" .. cPrefix("th => d") .. "|n|n" .. cPrefix("you => ya") .. "|n|n" .. cPrefix("ing => in'")
L.Options_Help_Examples3_Select = "old-fashioned"
L.Options_Help_Examples3_Header = cYellow("Use an outdate pronounciation.")
L.Options_Help_Examples3_Text = cPrefix("oi => oy") .. "|n|n" .. cPrefix("do => doe") .. "|n|n" .. cPrefix("go => goe") .. "|n|n" .. cPrefix("you => thou") .. "|n|n" .. cPrefix("yours => thy") .. "|n|n" .. cPrefix("be => bee") .. "|n|n" .. cPrefix("we => wee")
L.Options_Help_Examples4_Select = "abbreviations"
L.Options_Help_Examples4_Header = cYellow("Say much, type less.")
L.Options_Help_Examples4_Text = cPrefix("gz => Congratulations") .. "|n|n" .. cPrefix("gn8 => Good night") .. "|n|n" .. cPrefix("afk => I'm temporarikly not available (AFK)") .. "|n|n" .. cPrefix("MC => Molten Core")
L.Options_Help_Examples5_Select = "Proper names"
L.Options_Help_Examples5_Header = cYellow("Replace player names, NPCs or locations.")
L.Options_Help_Examples5_Text = "exact case is recommended|n|n" .. cPrefix("Sylvanas => the revengeful banshee queen") .. "|n|n" .. cPrefix("Asmongold => Asmon") .. "|n|n" .. cPrefix("Crossroads => X-roads")
L.Options_Help_Examples6_Select = "lisp"
L.Options_Help_Examples6_Header = cYellow("S and Z will become a sibilant")
L.Options_Help_Examples6_Text = cPrefix("s => th") .. "|n|n" .. cPrefix("ch => tsh") .. "|n|n" .. cPrefix("z => tsh") .. "|n|n" .. cPrefix("dg => ck")
L.Options_Help_Examples7_Select = "stammer"
L.Options_Help_Examples7_Header = cYellow("stammer")
L.Options_Help_Examples7_Text = "p[% s]-$"

L.IgnorePattern_Star = "Star"
L.IgnorePattern_Circle = "Circle"
L.IgnorePattern_Diamond = "Diamond"
L.IgnorePattern_Triangle = "Triangle"
L.IgnorePattern_Moon = "Moon"
L.IgnorePattern_Square = "Square"
L.IgnorePattern_Cross = "Cross"
L.IgnorePattern_Skull = "Skull"